#!/usr/bin/python
# -*- coding: utf-8 -*-

# xwget-full
# Скачивалка сайтов (версия полная)
# Скачивание сайтов для локального просмотра на компьютере
# Автор: phucker http://phucker.narod.ru http://arraylove.narod.ru
# Графический интерфейс пользователя для команды wget

# Подключаем необходимые библиотеки
from Tkinter import *
from ScrolledText import ScrolledText
import wx
import os

# Создаём основное окно
tk = Tk()
tk.title('Скачивалка сайтов xwget-full')

# Создаёт главное текстовое поле,
# на котором будем размещать все элементы управления 
# и сопровождающий текст
txt = ScrolledText(tk,wrap=WORD)
txt.pack(fill="both",expand=True)

# Класс "TextBox" объектов-виджетов, 
# предназначенных для ввода текста
class TextBox:
  def __init__(self):
    self.val=StringVar()
    self.wid=Entry(txt,textvariable=self.val,width=69)
    txt.window_create(END,window=self.wid)
    txt.insert(END, '\n')

# Класс объектов-виджетов, 
# предназначенных выбора одного из двух значений
# (Yes or No) (1 или 0)
class YoN:
  def __init__(self):
    self.val=IntVar()
    self.val.set(0)
    self.wid=Checkbutton(txt,text='да',variable=self.val,onvalue=1,offvalue=0)
    txt.window_create(END,window=self.wid)
    txt.insert(END, '\n')

# Класс объектов-виджетов, 
# предназначенных выбора одного из трёх значений
# (on, off или пусто)
class OnOff:
  def __init__(self):
    self.val=StringVar()
    self.wid0=Radiobutton(txt,text='скрыть',variable=self.val,value=' ')
    self.wid1=Radiobutton(txt,text='on',variable=self.val,value='on')
    self.wid2=Radiobutton(txt,text='off',variable=self.val,value='off')
    txt.window_create(END,window=self.wid0)
    txt.window_create(END,window=self.wid1)
    txt.window_create(END,window=self.wid2)
    self.val.set(' ')
    txt.insert(END, '\n')

# Класс объектов-виджетов, 
# предназначенных выбора одного из трёх значений
# (bar, dot или пусто)
class BarDot:
  def __init__(self):
    self.val=StringVar()
    self.wid0=Radiobutton(txt,text='пусто',variable=self.val,value=' ')
    self.wid1=Radiobutton(txt,text='bar',variable=self.val,value='bar')
    self.wid2=Radiobutton(txt,text='dot',variable=self.val,value='dot')
    txt.window_create(END,window=self.wid0)
    txt.window_create(END,window=self.wid1)
    txt.window_create(END,window=self.wid2)
    self.val.set(' ')
    txt.insert(END, '\n')

# Класс объектов-виджетов, 
# предназначенных выбора файла
class SelectFile:
  def __init__(self):
    self.val=StringVar()
    self.wid=Entry(txt,textvariable=self.val,width=69)    
    txt.window_create(END,window=self.wid)
    txt.insert(END, '\n')
    self.but=Button(txt,text="Выбрать",command=self.select)
    txt.window_create(END,window=self.but)
    txt.insert(END, '\n')
  def select(self):
    app = wx.PySimpleApp()
    wildcard = "*.*"
    dialog = wx.FileDialog(None, "Выбор файла", os.getcwd(), "", wildcard, wx.OPEN)
    #dialog = wx.FileDialog(None, "Выбор файла", os.getcwd(), "", wildcard, wx.SAVE)
    if dialog.ShowModal() == wx.ID_OK:
        self.val.set(dialog.GetPath())
    dialog.Destroy()

# Класс объектов-виджетов, 
# предназначенных выбора каталога
class SelectDir:
  def __init__(self):
    self.val=StringVar()
    self.wid=Entry(txt,textvariable=self.val,width=69)    
    txt.window_create(END,window=self.wid)
    txt.insert(END, '\n')
    self.but=Button(txt,text="Выбрать",command=self.select)
    txt.window_create(END,window=self.but)
    txt.insert(END, '\n')
  def select(self):
    app = wx.PySimpleApp()
    dialog = wx.DirDialog(None, "Выбор каталога", style=wx.DD_DEFAULT_STYLE | wx.DD_NEW_DIR_BUTTON)
    if dialog.ShowModal() == wx.ID_OK:
        self.val.set(dialog.GetPath())
    dialog.Destroy()

# Класс объектов-виджетов, 
# предназначенных выбора целых положительных чисел
class IntBox:
  def __init__(self):
    self.dig=IntVar()
    self.val=StringVar()
    self.wid=Entry(txt,textvariable=self.val,width=12)
    txt.window_create(END,window=self.wid)
    self.wid.bind('<KeyRelease>',self.prov)
    self.minus=Button(txt,text="-",command=self.f_minus)
    txt.window_create(END,window=self.minus)
    self.plus=Button(txt,text="+",command=self.f_plus)
    txt.window_create(END,window=self.plus)
    self.ubra=Button(txt,text="Пусто",command=self.f_ubra)
    txt.window_create(END,window=self.ubra)
    txt.insert(END, '\n')
  def add(self,x):
    st=self.val.get()
    st2=''
    for i in range(len(st)):
      ch=st[i]
      if ch.isdigit():
        st2=st2+ch
    if st2.isdigit():
      a=int(st2)
    else:
      a=0
    a=a+x
    if a<0:
      a=0
    st=str(a)
    self.val.set(st)
  def f_minus(self):
    self.add(-1)
  def f_plus(self):
    self.add(1)
  def f_ubra(self):
    self.val.set('')
  def prov(self,event):
    self.add(0)

# Процедура формирования командной строки
# для последующего запуска в xterm
# Срабатывает при нажатии кнопки "Собрать"
def pro1():

  st='wget'

  st2=output_file.val.get()
  if st2.replace(' ','')!='':
    st=st+' --output-file="'+st2+'"'

  st2=append_output.val.get()
  if st2.replace(' ','')!='':
    st=st+' --append-output="'+st2+'"'

  if debug.val.get()==1:
    st=st+' --debug'

  if quiet.val.get()==1:
    st=st+' --quiet'

  if verbose.val.get()==1:
    st=st+' --verbose'

  if non_verbose.val.get()==1:
    st=st+' --non-verbose'

  st2=input_file.val.get()
  if st2.replace(' ','')!='':
    st=st+' --input-file="'+st2+'"'

  if force_html.val.get()==1:
    st=st+' --force-html'

  st2=base.val.get()
  st2=st2.replace(' ','')
  if st2!='':
    st=st+' --base='+st2

  st2=bind_adress.val.get()
  st2=st2.replace(' ','')
  if st2!='':
    st=st+' --bind-adress='+st2 

  st2=tries.val.get()
  st2=st2.replace(' ','')
  if st2!='':
    st=st+' --tries='+st2 

  st2=output_document.val.get()
  if st2.replace(' ','')!='':
    st=st+' --output-document="'+st2+'"'

  if no_clobber.val.get()==1:
    st=st+' --no-clobber'

  if continue_.val.get()==1:
    st=st+' --continue' 

  st2=progress.val.get()
  st2=st2.replace(' ','')
  if st2!='':
    st=st+' --progress='+st2

  if timestamping.val.get()==1:
    st=st+' --timestamping'

  if server_response.val.get()==1:
    st=st+' --server-response'

  if spider.val.get()==1:
    st=st+' --spider'  

  st2=timeout.val.get()
  st2=st2.replace(' ','')
  if st2!='':
    st=st+' --timeout='+st2 

  st2=wait.val.get()
  st2=st2.replace(' ','')
  if st2!='':
    st=st+' --wait='+st2 

  st2=waitretry.val.get()
  st2=st2.replace(' ','')
  if st2!='':
    st=st+' --waitretry='+st2 

  if random_wait.val.get()==1:
    st=st+' --random-wait'

  st2=proxy.val.get()
  st2=st2.replace(' ','')
  if st2!='':
    st=st+' --proxy='+st2

  st2=quota.val.get()
  st2=st2.replace(' ','')
  if st2!='':
    st=st+' --quota='+st2

  if no_directories.val.get()==1:
    st=st+' --no-directories'

  if force_directories.val.get()==1:
    st=st+' --force-directories'

  if no_host_directories.val.get()==1:
    st=st+' --no-host-directories'

  st2=directory_prefix.val.get()
  if st2.replace(' ','')!='':
    st=st+' --directory-prefix="'+st2+'"'

  if html_extension.val.get()==1:
    st=st+' --html-extension'

  st2=http_user.val.get()
  if st2.replace(' ','')!='':
    st=st+' --http-user="'+st2+'"'
    #Читаем пароль только при
    #непустом логине  
    st2=http_passwd.val.get()
    if st2.replace(' ','')!='':
      st=st+' --http-passwd="'+st2+'"'

  st2=cache.val.get()
  st2=st2.replace(' ','')
  if st2!='':
    st=st+' --cache='+st2

  st2=cookies.val.get()
  st2=st2.replace(' ','')
  if st2!='':
    st=st+' --cookies='+st2

  st2=load_cookies.val.get()
  if st2.replace(' ','')!='':
    st=st+' --load-cookies="'+st2+'"'

  st2=save_cookies.val.get()
  if st2.replace(' ','')!='':
    st=st+' --save-cookies="'+st2+'"'

  if ignore_length.val.get()==1:
    st=st+' --ignore-length'

  st2=additional_header.val.get()
  if st2.replace(' ','')!='':
    st=st+' --additional-header="'+st2+'"'

  st2=proxy_user.val.get()
  if st2.replace(' ','')!='':
    st=st+' --proxy-user="'+st2+'"'
    #Читаем пароль только при
    #непустом логине  
    st2=proxy_passwd.val.get()
    if st2.replace(' ','')!='':
      st=st+' --proxy-passwd="'+st2+'"'  

  st2=referer.val.get()
  st2=st2.replace(' ','')
  if st2!='':
    st=st+' --referer='+st2

  if save_headers.val.get()==1:
    st=st+' --save-headers'

  st2=user_agent.val.get()
  if st2.replace(' ','')!='':
    st=st+' --user-agent="'+st2+'"'

  if dont_remove_listing.val.get()==1:
    st=st+' --dont-remove-listing'

  st2=glob.val.get()
  st2=st2.replace(' ','')
  if st2!='':
    st=st+' --glob='+st2

  if passive_ftp.val.get()==1:
    st=st+' --passive-ftp'

  if retr_symlinks.val.get()==1:
    st=st+' --retr-symlinks'

  if recursive.val.get()==1:
    st=st+' --recursive'
 
  st2=level.val.get()
  st2=st2.replace(' ','')
  if st2!='':
    st=st+' --level='+st2

  if delete_after.val.get()==1:
    st=st+' --delete-after'

  if convert_links.val.get()==1:
    st=st+' --convert-links'

  if backup_converted.val.get()==1:
    st=st+' --backup-converted'

  if mirror.val.get()==1:
    st=st+' --mirror'

  if page_requisites.val.get()==1:
    st=st+' --page-requisites'

  st2=accept.val.get()
  if st2.replace(' ','')!='':
    st=st+' --accept="'+st2+'"'

  st2=reject.val.get()
  if st2.replace(' ','')!='':
    st=st+' --reject="'+st2+'"'

  st2=domains.val.get()
  if st2.replace(' ','')!='':
    st=st+' --domains="'+st2+'"'

  st2=exclude_domains.val.get()
  if st2.replace(' ','')!='':
    st=st+' --exclude-domains="'+st2+'"'

  if follow_ftp.val.get()==1:
    st=st+' --follow-ftp'

  st2=follow_tags.val.get()
  if st2.replace(' ','')!='':
    st=st+' --follow-tags="'+st2+'"'

  st2=ignore_tags.val.get()
  if st2.replace(' ','')!='':
    st=st+' --ignore-tags="'+st2+'"'

  if span_hosts.val.get()==1:
    st=st+' --span-hosts'

  if relative.val.get()==1:
    st=st+' --relative'

  st2=include_directories.val.get()
  if st2.replace(' ','')!='':
    st=st+' --include-directories="'+st2+'"'

  st2=exclude_directories.val.get()
  if st2.replace(' ','')!='':
    st=st+' --exclude-directories="'+st2+'"'

  if no_parent.val.get()==1:
    st=st+' --no-parent'

  st2=url.val.get()
  st2=st2.replace(' ','')
  if st2=='':
    st2='sbnt.ru'
  st=st+' '+st2 

  com_wid.delete(1.0,END)
  com_wid.insert(END, st)

# Функция запуска команды Wget 
# в консоли XTerm
# Срабатывает при нажатии клавиши "Старт"
def pro2():
  st = com_wid.get('0.1', END)
  st = st.replace('\n',' ')
  os.system('/usr/bin/xterm -e ' + st)

# Создаём многострочный текстовое поле 
# для набора, автогенерации и редактирования команды Wget
com_str=StringVar()
com_wid=Text(txt,width=69,height=5,wrap=WORD)
#,foreground='#006900',font=('Arial',16,'bold')
txt.window_create(END,window=com_wid)
com_wid.insert(END, 'wget -r -k -l 7 -p -E -nc -np alfamodel7li.7li.ru')
txt.insert(END, '\n')
# Добавляем клавиши "Собрать" и "Старт"
but1=Button(txt,text="Собрать",command=pro1)
txt.window_create(END,window=but1)
but2=Button(txt,text="Старт",command=pro2)
txt.window_create(END,window=but2)
txt.insert(END, '\n')


# Выводим в окно элементы управления
# и пояснительный текст к ним
txt.insert(END, '\n')
txt.insert(END, '\n')
txt.insert(END, '\n')
txt.insert(END, 'ОПИСАНИЕ\n', 'cc')
txt.insert(END, '\n')
txt.insert(END, 'GNU Wget - это открыто распостраняемая утилита для загрузки файлов из интернет. Она поддерживает протоколы HTTP, HTTPS, и FTP, загрузку с серверов прокси по протоколу HTTP.\n')
txt.insert(END, '\n')
txt.insert(END, 'Wget может следовать по ссылкам страниц HTML и создавать локальные копии удаленных сайтов web, при этом возможно полное восстановление структуры папок сайта ("recursive downloading" - рекурсивная загрузка). Во время такой работы Wget ищет файл с правами доступа для роботов (/robots.txt). Возможна также конвертация ссылок в загруженных файлах HTML для дальнейшего просмотра сайта в автономном режиме ("off-line browsing").\n')
txt.insert(END, '\n')
txt.insert(END, 'Проверка заголовков файлов: Wget может считывать заголовки файлов (это доступно по протоколам HTTP и FTP) и сравнивать их с заголовкам ранее загруженных файлов, после чего может загрузить новые версии файлов. Благодаря этому при использовании Wget можно реализовывать зеркальное хранение сайтов или набора файлов на FTP.\n')
txt.insert(END, '\n')
txt.insert(END, 'Wget разработан для медленных или нестабильных соединений: если во время загрузки возникнет проблема, то Wget будет пытаться продолжить загрузку файла. Если сервер, с которого загружается файл, поддерживает докачку файлов, то Wget продолжит загружать файл именно с того места, где оборвалась загрузка. \n')
txt.insert(END, '\n')
txt.insert(END, '\n')
txt.insert(END, '\n')
txt.insert(END, 'СИНТАКСИС\n', 'cc')
txt.insert(END, '\n')
txt.insert(END, 'wget [параметры] [URL]\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, '\n')
txt.insert(END, '\n')

txt.insert(END, 'URL (UNIVERSAL RESOURCE LOCATOR) – АДРЕС СТРАНИЦЫ В ИНТЕРНЕТЕ\n', 'bb')
url=TextBox()
url.val.set('sbnt.ru')

txt.insert(END, '\n')
txt.insert(END, '\n')
txt.insert(END, '\n')

txt.insert(END, 'ПАРАМЕТРЫ СООБЩЕНИЙ\n', 'cc')
txt.insert(END, '\n')

txt.insert(END, '-o logfile\n', 'bb')
txt.insert(END, '--output-file=logfile\n', 'bb')
output_file=SelectFile()
txt.insert(END, 'Записывать все сообщения в logfile. Иначе они будут направлены в stderr.\n')
txt.insert(END, '\n')

txt.insert(END, '-a logfile\n', 'bb')
txt.insert(END, '--append-output=logfile\n', 'bb')
append_output=SelectFile()
txt.insert(END, 'Дополнить logfile. Как и -o, только logfile не заменяется, а дополняется. Если logfile не существует, создается новый файл.\n')
txt.insert(END, '\n')

txt.insert(END, '-d\n', 'bb')
txt.insert(END, '--debug\n', 'bb')
debug=YoN()
txt.insert(END, 'Отображать сообщения отладки - разная информация, важная для разработчиков Wget.\n')
txt.insert(END, '\n')

txt.insert(END, '-q\n', 'bb')
txt.insert(END, '--quiet\n', 'bb')
quiet=YoN()
txt.insert(END, 'Выключить сообщения Wget.\n')
txt.insert(END, '\n')

txt.insert(END, '-v\n', 'bb')
txt.insert(END, '--verbose\n', 'bb')
verbose=YoN()
txt.insert(END, 'Включить подробные сообщения, со всеми доступными данными. По умолчанию включено.\n')
txt.insert(END, '\n')

txt.insert(END, '-nv\n', 'bb')
txt.insert(END, '--non-verbose\n', 'bb')
non_verbose=YoN()
txt.insert(END, 'Исопльзовать сокращенные сообщения (чтобы выключить сообщения, см. -q). Сообщения об ошибках и основная информация будут отображаться.\n')
txt.insert(END, '\n')

txt.insert(END, '-i file\n', 'bb')
txt.insert(END, '--input-file=file\n', 'bb')
input_file=SelectFile()
txt.insert(END, 'Считать URL из file. В этом случае указывать URL в командной строке не требуется. Если URL указаны и в командной строке и в file, то сначала будут загружены URL из командной строки. file не обязательно должен иметь формат HTML (но ничего страшного, если это так) -- URL просто должны быть указаны в нем.\n')
txt.insert(END, '\n')
txt.insert(END, 'Если вы укажете --force-html, то файл будет прочтен как html. В этом случае могут возникнуть проблемы с относительными ссылками. Это можно предотвратить добавлением в него "<base href="url">" или вводом в командной строке --base=url.\n')
txt.insert(END, '\n')

txt.insert(END, '-F\n', 'bb')
txt.insert(END, '--force-html\n', 'bb')
force_html=YoN()
txt.insert(END, 'При чтении URL из файла, включает чтение файла как HTML. Для предотвращения ошибок в случае локального файла HTML добавьте в файл "<base href="url">" или введите параметр командной строки --base.\n')
txt.insert(END, '\n')

txt.insert(END, '-B URL\n', 'bb')
txt.insert(END, '--base=URL\n', 'bb')
base=TextBox()
txt.insert(END, 'При чтении URL из файла (-F) определяет URL, добавляемый к относительным адресам файла, указанного параметром -i.\n')
txt.insert(END, '\n')

txt.insert(END, '\n')
txt.insert(END, '\n')
txt.insert(END, '\n')

txt.insert(END, 'ПАРАМЕТРЫ ЗАГРУЗКИ\n', 'cc')
txt.insert(END, '\n')

txt.insert(END, '--bind-address=ADDRESS\n', 'bb')
bind_adress=TextBox()
txt.insert(END, 'При соединениях по протоколам TCP/IP передает "bind()" в ADDRESS на локальной машине. В ADDRESS может быть указано как имя хоста, так и IP адрес. Используется, если ваш компьютер имеет несколько адресов IP.\n')
txt.insert(END, '\n')

txt.insert(END, '-t number\n', 'bb')
txt.insert(END, '--tries=number\n', 'bb')
tries=IntBox()
txt.insert(END, 'Устанавливает число повторов number. Укажите 0 или inf для отмены повторов.\n')
txt.insert(END, '\n')

txt.insert(END, '-O file\n', 'bb')
txt.insert(END, '--output-document=file\n', 'bb')
output_document=SelectFile()
txt.insert(END, 'Документы не будут записываться в соответствующие файлы, а будут объединены вместе и записаны в файл file. Если file существует, то он будет заменен. Если file указан, как -, то документы будут выводиться на стандартный вывод (stdout). Этот параметр автоматически устанавливает число повторов в 1. Полезен при закачке разделенных на части файлов с почтовых серверов через интерфейс web.\n')
txt.insert(END, '\n')

txt.insert(END, '-nc\n', 'bb')
txt.insert(END, '--no-clobber\n', 'bb')
no_clobber=YoN()
txt.insert(END, 'Если при загрузке сайта связь оборвалась, то укажите этот параметр для продолжения загрузки с места прерывания связи.\n')
txt.insert(END, '\n')
txt.insert(END, 'При запуске Wget без параметров -N, -nc, или -r загрузка одного и того же файла в одну папку приведет к созданию копии файла с именем file.1. Если существует файл и с таким именем, третья копия будет называться file.2 и т.д. При параметре -nc будут выводиться предупреждения об этом.\n')
txt.insert(END, '\n')
txt.insert(END, 'При запуске Wget с параметром -r, но без -N или -nc, новая загрузка сайта приведет к замене уже загруженных файлов. При указании параметра -nc загрузка продолжится с места обрыва и загруженные файлы не будут загружаться заново (если только они не изменились).\n')
txt.insert(END, '\n')
txt.insert(END, 'При запуске Wget с параметром -N, с или без -r, файл будет загружен только если он новее уже существующего, или если размер его не совпадает с имеющейся копией (см. Сравнение по дате). -nc не комбинируется с -N.\n')
txt.insert(END, '\n')
txt.insert(END, 'При указанном параметре -nc файлы с расширениями .html или (вот это просто ужасно) .htm с локальных дисков будут загружаться, как будто бы из интернет.\n')
txt.insert(END, '\n')

txt.insert(END, '-c\n', 'bb')
txt.insert(END, '--continue\n', 'bb')
continue_=YoN()
txt.insert(END, 'Возобновление загрузки файла. Используется, если загрузка файла была прервана. Например:\n')
txt.insert(END, '\n')
txt.insert(END, 'wget -c ftp://sunsite.doc.ic.ac.uk/ls-lR.Z\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'Если в текущей папке уже есть файл с именем ls-lR.Z, то Wget проверит, соответствует ли данный файл загружаемому (не по размеру!), и если это так, то отправит запрос на сервер на продолжение загрузки файла с того же места, где оборвалась загрузка в прошлый раз.\n')
txt.insert(END, '\n')
txt.insert(END, 'Помните, что при обрыве связи Wget повторяет попытки дозагрузки самостоятельно и без параметра -c, и только когда он "сдастся" и завершит свою работу, то для возобновления загрузки файла будет нужен этот параметр.\n')
txt.insert(END, '\n')
txt.insert(END, 'Без указания опции -c предыдущий пример приведет к загрузке указанного файла заново с конечным именем ls-lR.Z.1, никак не трогая уже имеющийся ls-lR.Z.\n')
txt.insert(END, '\n')
txt.insert(END, 'Начиная с версии 1.7 при указании параметра -c если файл на сервере имеет равный или меньший, чем у локального файла, размер, то Wget не будет ничего загружать и отобразит соответствующее сообщение.\n')
txt.insert(END, '\n')
txt.insert(END, 'Однако, при использовании -c любой файл на сервере, имеющий больший размер, чем локальный файл, будет рассматриваться, как недокачанный. При этом будет загружено и записано в конец файла только "(длина(удал.файл) - длина(локал.файл))" байт. Это может пригодиться, елси вам нужно загрузить новые сообщения из какого-либо журнала (log).\n')
txt.insert(END, '\n')
txt.insert(END, 'При этом если загружаемый файл больше потому, что он изменился, то вы получите поврежденный файл (т.е. файл может в итоге получиться совершенно отличным от оригинала). Нужно быть особенно внимательным при использовании -c вместе с -r, так как каждый измененный файл может быть кандидатом на "незавершенную загрузку".\n')
txt.insert(END, '\n')
txt.insert(END, 'Вы также получите поврежденный файл если ваш сервер прокси HTTP работает глупо и при обрыве соединения пишет в файл сообщение "transfer interrupted". Вероятно, в следующих версиях Wget сам будет исправлять это.\n')
txt.insert(END, '\n')
txt.insert(END, 'Помните, что -c работает только с серверами FTP и HTTP, поддерживающими заголовки "Range" (т.е. докачку файлов).\n')
txt.insert(END, '\n')

txt.insert(END, '--progress=type\n', 'bb')
progress=BarDot()
txt.insert(END, 'Индикатор прогресса загрузки и его тип. Возможные значения: "dot" и "bar".\n')
txt.insert(END, '\n')
txt.insert(END, 'По умолчанию используется "bar". Указание опции --progress=bar приведет к прорисовке красивого индикатора из символов ASCII (как "термометр"). Если стандартный выход не TTY, то будет использован "dot".\n')
txt.insert(END, '\n')
txt.insert(END, 'Укажите --progress=dot чтобы переключится на тип "dot". Прогресс загрузки будет отмечаться добавлением в полосе точки или знака равно, каждый символ представляет одинаковое количество данных.\n')
txt.insert(END, '\n')
txt.insert(END, 'При использовании этого типа, вы можете указать его стиль - dot:style. Если стиль "default", то каждый символ будет представлять 1 Kб, 10 символов в кластере и 50 в строке. Стиль "binary" имеет более "компьютерный" вид - 8Kб в символе, 16 символов в кластере и 48 символов в строке (получается строка на 384 Kб). Стиль "mega" используется для загрузки больших файлов - каждый символ представляет 64Kб, 8 символов в кластере и 48 символов в строке (получается 3 Mб на строку).\n')
txt.insert(END, '\n')
txt.insert(END, 'Вы можете определить стиль по умолчанию, используя команду "progress" в .wgetrc. Если вы хотите, чтобы тип индикатора "bar" использовался всегда (а не только при выводе в stdout), то укажите --progress=bar:force.\n')
txt.insert(END, '\n')

txt.insert(END, '-N\n', 'bb')
txt.insert(END, '--timestamping\n', 'bb')
timestamping=YoN()
txt.insert(END, 'Включить сравнение по дате.\n')
txt.insert(END, '\n')

txt.insert(END, '-S\n', 'bb')
txt.insert(END, '--server-response\n', 'bb')
server_response=YoN()
txt.insert(END, 'Отображать заголовки, отправляемые серверам HTTP и запросы, отправляемые серверам FTP.\n')
txt.insert(END, '\n')

txt.insert(END, '--spider\n', 'bb')
spider=YoN()
txt.insert(END, 'Установка поведения Wget как "паука", т. е. Wget не будет загружать файлы, а только будет проверять их наличие. Так можно проверять закладки и ссылки сайта. Например:\n')
txt.insert(END, '\n')
txt.insert(END, 'wget --spider --force-html -i bookmarks.html\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'Wget не содержит все возможности "настоящих пауков" для WWW.\n')
txt.insert(END, '\n')

txt.insert(END, '-T seconds\n', 'bb')
txt.insert(END, '--timeout=seconds\n', 'bb')
timeout=IntBox()
txt.insert(END, 'Время ожидания в секундах. По умолчанию время ожидания равно 900 с (15 мин). Установка значения в 0 отменяет проверку времени ожидания.\n')
txt.insert(END, '\n')
txt.insert(END, 'Пожалуйста, не снижайте значение времени ожидания, если Вы точно не знаете, что именно делаете.\n')
txt.insert(END, '\n')

txt.insert(END, '-w seconds\n', 'bb')
txt.insert(END, '--wait=seconds\n', 'bb')
wait=IntBox()
txt.insert(END, 'Пауза в секундах между несколькими загрузками (в т.ч. повторами). Это снижает загруженность сервера. Чтобы указать значение в минутах, используйте "m", в часах - "h", в днях - "d" после числа.\n')
txt.insert(END, '\n')
txt.insert(END, 'Указание большого значения этого параметра полезно, если сеть нестабильна (например при обрывах модемной связи).\n')
txt.insert(END, '\n')

txt.insert(END, '--waitretry=seconds\n', 'bb')
waitretry=IntBox()
txt.insert(END, 'Устанавливает паузу только между повторами оборвавшихся загрузок. Wget будет ждать 1 секунду после первого обрыва, 2 секунды после второго обрыва загрузки того же файла, и т.д. - до максимума, который указывается в секундах. Например, при значении данного параметра, равного 10, Wget будет ждать в общем (1 + 2 + ... + 10) = 55 секунд для каждого файла.\n')
txt.insert(END, '\n')
txt.insert(END, 'Это значение указывается по умолчанию в файле wgetrc.\n')
txt.insert(END, '\n')

txt.insert(END, '--random-wait\n', 'bb')
random_wait=YoN()
txt.insert(END, 'Некоторые серверы, совершая формирование файлов журналов с паузами запросов файлов, могут определить рекурсивную загрузку файлов - сканирование роботами, такими, как Wget. Этот параметр устанавливает время между запросами, варьируя паузы со временем, рассчитываемым от 0 до 2*wait (секунд), где wait указано параметром -w для маскировки Wget.\n')
txt.insert(END, '\n')
txt.insert(END, 'Нельзя забывать, что исходный код Wget доступен, и пэтому даже эту маскировку при желании можно вычислить.\n')
txt.insert(END, '\n')

txt.insert(END, '-Y on/off\n', 'bb')
txt.insert(END, '--proxy=on/off\n', 'bb')
proxy=OnOff()
txt.insert(END, 'Поддержка сервера прокси. Включена по умолчанию, если прокси определен.\n')
txt.insert(END, '\n')

txt.insert(END, '-Q quota\n', 'bb')
txt.insert(END, '--quota=quota\n', 'bb')
quota=TextBox()
txt.insert(END, 'Квота на размер загружаемых файлов. Указывается в байтах (по умолчанию), в килобайтах Кб (если в конце k) или в мегабайтах Мб (если в конце m).\n')
txt.insert(END, '\n')
txt.insert(END, 'При исчерпании квоты текущий файл загружается до конца, то есть квота не работает при загрузке одного файла. Например, если вы исполните\n') 
txt.insert(END, 'wget -Q10k ftp://wuarchive.wustl.edu/ls-lR.gz \n', 'aa')
txt.insert(END, 'то файл ls-lR.gz будет полностью загружен. Также все указанные в командной строке файлы будут обязательно загружены, в отличие от списка файлов в одном файле или как при рекурсивной загрузке.\n')
txt.insert(END, '\n')
txt.insert(END, 'Указание 0 или inf отменит квоту.\n')
txt.insert(END, '\n')

txt.insert(END, '\n')
txt.insert(END, '\n')
txt.insert(END, '\n')

txt.insert(END, 'ПАРАМЕТРЫ ЗАГРУЗКИ ПАПОК\n', 'cc')
txt.insert(END, '\n')

txt.insert(END, '-nd\n', 'bb')
txt.insert(END, '--no-directories\n', 'bb')
no_directories=YoN()
txt.insert(END, 'Не создавать структуру папок при рекурсивной загрузке. При указанном параметре, все файлы будут загружаться в одну папку. Если файл с данным именем уже существует, то он будет сохранен под именем ИмяФайла.n.\n')
txt.insert(END, '\n')

txt.insert(END, '-x\n', 'bb')
txt.insert(END, '--force-directories\n', 'bb')
force_directories=YoN()
txt.insert(END, 'Противоположно параметру -nd - создавать структуру папок, начиная с главной страницы сервера. Например, \n')
txt.insert(END, 'wget -x http://fly.srk.fer.hr/robots.txt \n', 'aa')
txt.insert(END, 'приведет к загрузке файла в папку fly.srk.fer.hr.\n')
txt.insert(END, '\n')

txt.insert(END, '-nH\n', 'bb')
txt.insert(END, '--no-host-directories\n', 'bb')
no_host_directories=YoN()
txt.insert(END, 'Не создавать пустые папки в начале структуры. По умолчанию /pub/xemacs/. Если вы загрузите ее с параметром -r, то она сохранится под именем ftp.xemacs.org/pub/xemacs/. С параметром -nH из имени начальной папки вырежется ftp.xemacs.org/, и она будет называться pub/xemacs. А параметр --cut-dirs уберет number компонентов. Примеры работы параметра --cut-dirs:\n')
txt.insert(END, '\n')
txt.insert(END, 'Без параметров        -> ftp.xemacs.org/pub/xemacs/\n')
txt.insert(END, '-nH               -> pub/xemacs/\n')
txt.insert(END, '-nH --cut-dirs=1  -> xemacs/\n')
txt.insert(END, '-nH --cut-dirs=2  -> .\n')
txt.insert(END, '\n')
txt.insert(END, '--cut-dirs=1      -> ftp.xemacs.org/xemacs/\n')
txt.insert(END, '...\n')
txt.insert(END, '\n')
txt.insert(END, 'Если вы хотите просто избавиться от структуры папок, то вы можете заменить этот параметр на -nd и -P. В отличие от -nd, -nd работает с подкаталогами - например, при -nH --cut-dirs=1 подкаталог beta/ запишется, как xemacs/beta.\n')
txt.insert(END, '\n')

txt.insert(END, '-P prefix\n', 'bb')
txt.insert(END, '--directory-prefix=prefix\n', 'bb')
directory_prefix=SelectDir()
txt.insert(END, 'Определяет начальную папку, в которой будет сохранена структура папок сайта (или просто файлы). По умолчанию этот параметр равен . (текущая папка).\n')
txt.insert(END, '\n')

txt.insert(END, '\n')
txt.insert(END, '\n')
txt.insert(END, '\n')

txt.insert(END, 'ПАРАМЕТРЫ HTTP\n', 'cc')
txt.insert(END, '\n')

txt.insert(END, '-E\n', 'bb')
txt.insert(END, '--html-extension\n', 'bb')
html_extension=YoN()
txt.insert(END, 'Если тип загруженного файла text/html и его адрес не оканчивается на \.[Hh][Tt][Mm][Ll]?, при использовании данного параметра к его имени будет добавлено .html. Это может быть полезно при зеркальном хранении страниц .asp, если вы не хотите, чтобы они вмешивались в работу вашего сервера Apache. Другой случай применения этого парамера - это загрузка страниц-ответов CGI скриптов. Страница с URL вида http://site.com/article.cgi?25 будет сохранена, как article.cgi?25.html.\n')
txt.insert(END, '\n')
txt.insert(END, 'Примечание: при обновлении или другой перезагрузке страниц с данным параметром последние будут загружаться заново в любом случае, т.к. Wget не может узнать, имеет ли отношение локальный файл X.html к загружаемому с URL X. Чтобы избежать лишней перезагрузки, используйте опции -k и -K. При этом оригинальные версии файлов будут также сохранены как X.orig.\n')
txt.insert(END, '\n')

txt.insert(END, '--http-user=user\n', 'bb')
http_user=TextBox()
txt.insert(END, '--http-passwd=password\n', 'bb')
http_passwd=TextBox()
txt.insert(END, 'Имя пользователя user и пароль password для сервера HTTP. В зависимости от типа отклика, Wget будет использовать "basic" (небезопасную) или "digest" (защищенную) авторизацию.\n')
txt.insert(END, '\n')
txt.insert(END, 'Можно также указывать имя пользователя и пароль и в самом URL.\n')
txt.insert(END, '\n')

txt.insert(END, '-C on/off\n', 'bb')
txt.insert(END, '--cache=on/off\n', 'bb')
cache=OnOff()
txt.insert(END, 'Включает или выключает кеширование со стороны сервера. При этом Wget посылает соответствующих запрос (Pragma: no-cache). Также используется для быстрого обновления файлов на прокси-сервере.\n')
txt.insert(END, '\n')
txt.insert(END, 'По умолчанию кеширование разрешено.\n')
txt.insert(END, '\n')

txt.insert(END, '--cookies=on/off\n', 'bb')
cookies=OnOff()
txt.insert(END, 'Включает или выключает использование cookie. Сервер отправляет клиенту cookie, используя заголовок "Set-Cookie" и клиент отвечает таким же cookie. Благодаря этому сервер может вести статистику посетителей. По умолчанию cookie используются, но запись их на диск выключена.\n')
txt.insert(END, '\n')

txt.insert(END, '--load-cookies=file\n', 'bb')
load_cookies=SelectFile()
txt.insert(END, 'Загружать cookie из file перед первой загрузкой HTTP. file имеет текстовый формат, как cookies.txt у Netscape.\n')
txt.insert(END, '\n')
txt.insert(END, 'Этот параметр используется при зеркалировании. Для этого Wget отправляет те же cookies, которые отправляет ваш браузер при соединении с сервером HTTP. Это включается данным параметром - просто укажите Wget путь к cookies.txt. Разные браузеры хранят cookie в разных папках:\n')
txt.insert(END, '\n')
txt.insert(END, 'Netscape 4.x.\n')
txt.insert(END, 'Файл находится в ~/.netscape/cookies.txt.\n')
txt.insert(END, 'Mozilla и Netscape 6.x.\n')
txt.insert(END, 'Mozilla хранит cookies в cookies.txt, расположенном где-то в ~/.mozilla, в папке вашего профиля. Полный путь обычно заканчивается чем-то вроде ~/.mozilla/default/some-weird-string/cookies.txt.\n')
txt.insert(END, 'Internet Explorer.\n')
txt.insert(END, 'Чтобы экспортировать cookie для Wget, выберите "Файл", "Импорт и Экспорт", в мастере выберите "Экспорт файлов cookie". Проверено в Internet Explorer 5; возможно не будет работать в ранних версиях.\n')
txt.insert(END, 'Другие обозреватели.\n')
txt.insert(END, 'Параметр --load-cookies будет работать с cookie в формате Netscape, который поддерживается Wget.\n')
txt.insert(END, '\n')
txt.insert(END, 'Если вы не можете использовать параметр --load-cookies, то все равно есть выход. Если ваш обозреватель поддерживает Запишите имя и значение cookie и вручную укажите Wget отправку этих cookie:\n')
txt.insert(END, '\n')
txt.insert(END, 'wget --cookies=off --header "Cookie: I<name>=I<value>"\n', 'aa')
txt.insert(END, '\n')

txt.insert(END, '--save-cookies=file\n', 'bb')
save_cookies=SelectFile()
txt.insert(END, 'Сохранить cookie из file в конце сессии. Устаревшие cookie не сохраняются.\n')
txt.insert(END, '\n')

txt.insert(END, '--ignore-length\n', 'bb')
ignore_length=YoN()
txt.insert(END, 'Некоторые серверы HTTP (точнее, скрипты CGI) отправляют заголовки "Content-Length", которые указывают Wget, что загружено еще не все. И Wget загружает один документ несколько раз.\n')
txt.insert(END, '\n')
txt.insert(END, 'С этим параметром, Wget будет игнорировать заголовки "Content-Length".\n')
txt.insert(END, '\n')

txt.insert(END, '--header=additional-header\n', 'bb')
additional_header=TextBox()
txt.insert(END, 'Определяет additional-header, отправляемый серверу HTTP. Он должен содержать : и символы после него.\n')
txt.insert(END, '\n')
txt.insert(END, 'Вы можете определить несколько дополнительных заголовков через использование --header несколько раз.\n')
txt.insert(END, '\n')
txt.insert(END, 'wget --header="Accept-Charset: iso-8859-2" \ \n', 'aa')
txt.insert(END, '--header="Accept-Language: hr"        \ \n', 'aa')
txt.insert(END, 'http://fly.srk.fer.hr/ \n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'Указание пустой строки в значении заголовка очистит все определенные пользователем до этого заголовки.\n')
txt.insert(END, '\n')

txt.insert(END, '--proxy-user=user\n', 'bb')
proxy_user=TextBox()
txt.insert(END, '--proxy-passwd=password\n', 'bb')
proxy_passwd=TextBox()
txt.insert(END, 'Определяет имя пользователя user и пароль password для авторизации сервере прокси. Будет использован тип авторизации "basic".\n')
txt.insert(END, '\n')

txt.insert(END, '--referer=url\n', 'bb')
referer=TextBox()
txt.insert(END, 'Добавляет заголовок "Referer: url" в запрос HTTP. Используется при загрузке страниц, которые передаются правильно только если сервер знает, с какой страницы вы пришли.\n')
txt.insert(END, '\n')

txt.insert(END, '-s\n', 'bb')
txt.insert(END, '--save-headers\n', 'bb')
save_headers=YoN()
txt.insert(END, 'Сохранять заголовки, отправляемые серверам HTTP.\n')
txt.insert(END, '\n')

txt.insert(END, '-U agent-string\n', 'bb')
txt.insert(END, '--user-agent=agent-string\n', 'bb')
user_agent=TextBox()
txt.insert(END, 'Идентифицироваться, как agent-string при запросе на HTTP сервер.\n')
txt.insert(END, '\n')
txt.insert(END, 'Протокол HTTP позволяет определять себя использованием заголовка агента. Wget по умолчанию идентифицируется, как Wget/version, где version - это версия Wget.\n')
txt.insert(END, '\n')
txt.insert(END, 'Некоторые серверы выдают требуемую информацию только для обозревателей, идентифицирующихся как "Mozilla" или Microsoft "Internet Explorer". Этот параметр позволяет обмануть такие серверы.\n')
txt.insert(END, '\n')

txt.insert(END, '\n')
txt.insert(END, '\n')
txt.insert(END, '\n')

txt.insert(END, 'ПАРАМЕТРЫ FTP\n', 'cc')
txt.insert(END, '\n')

txt.insert(END, '-nr\n', 'bb')
txt.insert(END, '--dont-remove-listing\n', 'bb')
dont_remove_listing=YoN()
txt.insert(END, 'Не удалять временные файлы .listing, генерируемые при загрузке по FTP. Эти файлы содержат информацию о папках серверов FTP. Неудаление поможет вам быстро определить обновление папок сервера (т.е. определять., что ваше зеркало является таковым).\n')
txt.insert(END, '\n')
txt.insert(END, 'Если вы не удаляете .listing, то помните о своей безопасности! Например, с таким именем можно создать символическую ссылку на /etc/passwd или что-то еще.\n')
txt.insert(END, '\n')

txt.insert(END, '-g on/off\n', 'bb')
txt.insert(END, '--glob=on/off\n', 'bb')
glob=OnOff()
txt.insert(END, 'Включает или выключает использование специальных символов (маски) по протоколу FTP. Это может быть *, ?, [ и ]. Например:\n')
txt.insert(END, '\n')
txt.insert(END, 'wget ftp://gnjilux.srk.fer.hr/*.msg\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'По умолчанию использование символов маски разрешено, если URL содержит такие символы.\n')
txt.insert(END, '\n')
txt.insert(END, 'Вы можете также взять URL в кавычки. Это сработает только на серверах Unix FTP (и эмулирующих выход Unix "ls").\n')
txt.insert(END, '\n')

txt.insert(END, '--passive-ftp\n', 'bb')
passive_ftp=YoN()
txt.insert(END, 'Включает пассивный режим FTP, когда соединение инициируется клиентом. Используется при наличии firewall.\n')
txt.insert(END, '\n')

txt.insert(END, '--retr-symlinks\n', 'bb')
retr_symlinks=YoN()
txt.insert(END, 'При рекурсивной загрузке папок FTP файлы, на которые указывают символические ссылки, не загружаются. Данный параметр отключает это.\n')
txt.insert(END, '\n')
txt.insert(END, 'Параметр --retr-symlinks работает сейчас только для файлов, не для папок.\n')
txt.insert(END, '\n')
txt.insert(END, 'Помните, что этот параметр не работает при загрузке одиночного файла.\n')
txt.insert(END, '\n')

txt.insert(END, '\n')
txt.insert(END, '\n')
txt.insert(END, '\n')

txt.insert(END, 'ПАРАМЕТРЫ РЕКУРСИВНОЙ ЗАГРУЗКИ\n', 'cc')
txt.insert(END, '\n')

txt.insert(END, '-r\n', 'bb')
txt.insert(END, '--recursive\n', 'bb')
recursive=YoN()
txt.insert(END, 'Включить рекурсивную загрузку.\n')
txt.insert(END, '\n')

txt.insert(END, '-l depth\n', 'bb')
txt.insert(END, '--level=depth\n', 'bb')
level=IntBox()
txt.insert(END, 'Максимальная глубина рекурсивной загрузки depth. По умолчанию ее значение равно 5.\n')
txt.insert(END, '\n')

txt.insert(END, '--delete-after\n', 'bb')
delete_after=YoN()
txt.insert(END, 'Удалять каждую страницу (локально) после ее загрузки. Используется для сохранения новых версий часто запрашиваемых страниц на прокси. Например:\n')
txt.insert(END, '\n')
txt.insert(END, 'wget -r -nd --delete-after http://whatever.com/~popular/page/\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'Параметр -r включает загрузку по умолчанию, параметр -nd отключает создание папок.\n')
txt.insert(END, '\n')
txt.insert(END, 'При указанном параметре --delete-after будет игнорироваться параметр --convert-links.\n')
txt.insert(END, '\n')

txt.insert(END, '-k\n', 'bb')
txt.insert(END, '--convert-links\n', 'bb')
convert_links=YoN()
txt.insert(END, 'После завершения загрузки конвертировать ссылки в документе для просмотра в автономном режиме. Это касается не только видимых ссылок на другие документы, а ссылок на все внешние локальные файлы.\n')
txt.insert(END, '\n')
txt.insert(END, 'Каждая ссылка изменяется одним из двух способов:\n')
txt.insert(END, '\n')
txt.insert(END, '* Ссылки на файлы, загруженные Wget изменяются на соответствующие относительные ссылки.\n')
txt.insert(END, '\n')
txt.insert(END, 'Например: если загруженный файл /foo/doc.html, то ссылка на также загруженный файл /bar/img.gif будет выглядеть, как ../bar/img.gif. Этот способ работает, если есть видимое соотношение между папками одного и другого файла.\n')
txt.insert(END, '\n')
txt.insert(END, '* Ссылки на файлы, не загруженные Wget будут изменены на абсолютные адреса этих файлов на удаленном сервере.\n')
txt.insert(END, '\n')
txt.insert(END, 'Например: если загруженный файл /foo/doc.html содержит ссылку на /bar/img.gif (или на ../bar/img.gif), то ссылка в файле doc.html изменится на http://host/bar/img.gif.\n')
txt.insert(END, '\n')
txt.insert(END, 'Благодаря этому, возможен автономный просмотр сайта и файлов: если загружен файл, на который есть ссылка, то ссылка будет указывать на него, если нет - то ссылка будет указывать на его адрес в интернет (если такой существует). При конвертировании используются относительные ссылки, значит вы сможете переносить загруженный сайт в другую папку, не меняя его структуру.\n')
txt.insert(END, '\n')
txt.insert(END, 'Только после завершения загрузки Wget знает, какие файлы были загружены. Следовательно, при параметре -k конвертация произойдет только по завершении загрузки.\n')
txt.insert(END, '\n')

txt.insert(END, '-K\n', 'bb')
txt.insert(END, '--backup-converted\n', 'bb')
backup_converted=YoN()
txt.insert(END, 'Конвертировать ссылки обратно - убирать расширение .orig. Изменяет поведение опции -N.\n')
txt.insert(END, '\n')

txt.insert(END, '-m\n', 'bb')
txt.insert(END, '--mirror\n', 'bb')
mirror=YoN()
txt.insert(END, 'Включить параметры для зеркального хранения сайтов. Этот параметр равен нескольким параметрам: -r -N -l inf -nr. Для неприхотливого хранения зеркальных копий сайтов вы можете использовать данный параметр.\n')
txt.insert(END, '\n')

txt.insert(END, '-p\n', 'bb')
txt.insert(END, '--page-requisites\n', 'bb')
page_requisites=YoN()
txt.insert(END, 'Загружать все файлы, которые нужны для отображения страниц HTML. Например: рисунки, звук, каскадные стили.\n')
txt.insert(END, '\n')
txt.insert(END, 'По умолчанию такие файлы не загружаются. Параметры -r и -l, указанные вместе могут помочь, но т.к. Wget не различает внешние и внутренние документы, то нет гарантии, что загрузится все требуемое.\n')
txt.insert(END, '\n')
txt.insert(END, 'Например, 1.html содержит тег "<IMG>", со ссылкой на 1.gif, и тег "<A>", ссылающийся на внешний документ 2.html. Страница 2.html аналогична, но ее рисунок - 2.gif и ссылается она на 3.html. Скажем, это продолжается до определенного числа.\n')
txt.insert(END, '\n')
txt.insert(END, 'Если будет дана команда:\n')
txt.insert(END, '\n')
txt.insert(END, 'wget -r -l 2 http://I<site>/1.html\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'то 1.html, 1.gif, 2.html, 2.gif и 3.html загрузятся. Как видим, 3.html без 3.gif, т.к. Wget просто считает число прыжков, по которым он перешел, доходит до 2 и останавливается. А при параметрах:\n')
txt.insert(END, '\n')
txt.insert(END, 'wget -r -l 2 -p http://I<site>/1.html\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'Все файлы и рисунок 3.gif страницы 3.html загрузятся. Аналогично\n')
txt.insert(END, '\n')
txt.insert(END, 'wget -r -l 1 -p http://I<site>/1.html\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'приведет к загрузке 1.html, 1.gif, 2.html и 2.gif. Чтобы загрузить одну указанную страницу HTML со всеми ее элементами, просто не указывайте -r и -l:\n')
txt.insert(END, '\n')
txt.insert(END, 'wget -p http://I<site>/1.html\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'При этом Wget будет себя вести, как при параметре -r, но будут загружены страница и ее вспомогательные файлы. Если вы хотите, чтобы вспомогательные файлы на других серверах (т.е. через абсолютные ссылки) были загружены, используйте:\n')
txt.insert(END, '\n')
txt.insert(END, 'wget -E -H -k -K -p http://I<site>/I<document>\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'И в завершении, нужно сказать, что для Wget внешняя ссылка - это URL, указанный в тегах "<A>", "<AREA>" и "<LINK>", кроме "<LINK REL="stylesheet">".\n')
txt.insert(END, '\n')

txt.insert(END, '\n')
txt.insert(END, '\n')
txt.insert(END, '\n')

txt.insert(END, 'ПАРАМЕТРЫ ЗАПРЕТА/РАЗРЕШЕНИЯ РЕКУРСИВНОЙ ЗАГРУЗКИ\n', 'cc')
txt.insert(END, '\n')

txt.insert(END, '-A acclist\n', 'bb')
txt.insert(END, '--accept=acclist\n', 'bb')
accept=TextBox()
txt.insert(END, 'Список имен файлов, разделенных запятыми, которые следует загружать. Разрешается задание имен файлов по маске.\n')
txt.insert(END, '\n')

txt.insert(END, '-R rejlist\n', 'bb')
txt.insert(END, '--reject=rejlist\n', 'bb')
reject=TextBox()
txt.insert(END, 'Список имен файлов, разделенных запятыми, которые не следует загружать. Разрешается задание имен файлов по маске.\n')
txt.insert(END, '\n')

txt.insert(END, '-D domain-list\n', 'bb')
txt.insert(END, '--domains=domain-list\n', 'bb')
domains=TextBox()
txt.insert(END, 'Список доменов domain-list, с которых разрешено загружать файлы. Разделяется запятыми. Этот параметр не включает -H.\n')
txt.insert(END, '\n')

txt.insert(END, '--exclude-domains=domain-list\n', 'bb')
txt.insert(END, 'Список доменов, с которых не разрешено загружать файлы\n')
exclude_domains=TextBox()
txt.insert(END, '\n')

txt.insert(END, '--follow-ftp\n', 'bb')
follow_ftp=YoN()
txt.insert(END, 'Следовать по ссылкам FTP с HTML страниц. Иначе, ссылки на файлы по протоколу FTP игнорируются.\n')
txt.insert(END, '\n')

txt.insert(END, '--follow-tags=list\n', 'bb')
follow_tags=TextBox()
txt.insert(END, 'Wget имеет встроенную таблицу тегов HTML, в которых он ищет ссылки на другие файлы. Вы можете указать дополнительные теги в разделенном запятыми списке list в этом параметре.\n')
txt.insert(END, '\n')

txt.insert(END, '-G list\n', 'bb')
txt.insert(END, '--ignore-tags=list\n', 'bb')
ignore_tags=TextBox()
txt.insert(END, 'Обратно --follow-tags. Для пропуска тегов HTML при рекурсивной загрузке, укажите их в разделенном запятыми списке list.\n')
txt.insert(END, '\n')
txt.insert(END, 'Раньше параметр -G был лучшим для загрузки отдельных страниц с их вспомогательными файлами. Вы можете посмотреть, как это было, указав команду\n')
txt.insert(END, '\n')
txt.insert(END, 'wget -Ga,area -H -k -K -r http://I<site>/I<document>\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'Но теперь лучшим параметром для загрузки одной страницы полностью считается --page-requisites.\n')
txt.insert(END, '\n')

txt.insert(END, '-H\n', 'bb')
txt.insert(END, '--span-hosts\n', 'bb')
span_hosts=YoN()
txt.insert(END, 'Разрешает посещать любые сервера, на которые есть ссылка.\n')
txt.insert(END, '\n')

txt.insert(END, '-L\n', 'bb')
txt.insert(END, '--relative\n', 'bb')
relative=YoN()
txt.insert(END, 'Следовать только по относительным ссылкам. При этом параметре файлы с других серверов точно не будут загружаться.\n')
txt.insert(END, '\n')

txt.insert(END, '-I list\n', 'bb')
txt.insert(END, '--include-directories=list\n', 'bb')
include_directories=TextBox()
txt.insert(END, 'Список папок, разделенных запятыми, из которых разрешено загружать файлы. Элементы списка list могут содержать символы масок.\n')
txt.insert(END, '\n')

txt.insert(END, '-X list\n', 'bb')
txt.insert(END, '--exclude-directories=list\n', 'bb')
exclude_directories=TextBox()
txt.insert(END, 'Список папок, разделенных запятыми, исключаемых для загрузки. Элементы списка list могут содержать символы масок.\n')
txt.insert(END, '\n')

txt.insert(END, '-np\n', 'bb')
txt.insert(END, '--no-parent\n', 'bb')
no_parent=YoN()
txt.insert(END, 'Не подниматься выше начального адреса при рекурсивной загрузке.\n')
txt.insert(END, '\n')

txt.insert(END, '\n')
txt.insert(END, '\n')
txt.insert(END, '\n')

txt.insert(END, 'ПРИМЕРЫ ИСПОЛЬЗОВАНИЯ\n', 'cc')
txt.insert(END, '\n')
txt.insert(END, 'Загрузка всех URL, указанных в файле FILE:\n')
txt.insert(END, 'wget -i FILE\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'Скачивание файла в указанный каталог (-P):\n')
txt.insert(END, 'wget -P /path/for/save ftp://ftp.example.org/some_file.iso\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'Использование имени пользователя и пароля на FTP/HTTP (вариант 1):\n')
txt.insert(END, 'wget ftp://login:password@ftp.example.org/some_file.iso\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'Использование имени пользователя и пароля на FTP/HTTP (вариант 2):\n')
txt.insert(END, 'wget --user=login --password=password ftp://ftp.example.org/some_file.iso\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'Скачивание в фоновом режиме (-b):\n')
txt.insert(END, 'wget -b ftp://ftp.example.org/some_file.iso\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'Продолжить (-c continue) загрузку ранее не полностью загруженного файла:\n')
txt.insert(END, 'wget -c http://example.org/file.iso\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'Скачать страницу с глубиной следования 10, записывая протокол в файл log:\n')
txt.insert(END, 'wget -r -l 10 http://example.org/ -o log\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'Скачать содержимое каталога http://example.org/~luzer/my-archive/ и всех его подкаталогов, при этом не поднимаясь по иерархии каталогов выше:\n')
txt.insert(END, 'wget -r --no-parent http://example.org/~luzer/my-archive/\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'Для того, чтобы во всех скачанных страницах ссылки преобразовывались в относительные для локального просмотра, необходимо использовать ключ -k:\n')
txt.insert(END, 'wget -r -l 10 -k http://example.org/\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, 'Также поддерживается идентификация на сервере:\n')
txt.insert(END, 'wget --save-cookies cookies.txt \\n', 'aa')
txt.insert(END, '--post-data "user=foo&password=bar" \\n')
txt.insert(END, 'http://example.org/auth.php\n')
txt.insert(END, '\n')
txt.insert(END, 'Вывести содержание ответа в консоль:\n')
txt.insert(END, 'wget  http://example.org --quiet -O -\n', 'aa')
txt.insert(END, '\n')
txt.insert(END, '\n')

# Задаём стили вывода различных областей текста
txt.tag_config('aa', foreground='#006900', font=('Arial',14,'bold'))
txt.tag_config('bb', foreground='navy', font=('Arial',16,'bold'))
txt.tag_config('cc', background='#00ffff', font=('Arial',22,'bold'))

tk.mainloop()
